diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/common/TimePeriodTest.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/common/TimePeriodTest.java
index 61e33ecf9f..ae1ce0a6f4 100644
--- a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/common/TimePeriodTest.java
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/common/TimePeriodTest.java
@@ -14,43 +14,40 @@ import static org.junit.Assert.assertFalse;
 import static org.junit.Assert.assertNotNull;
 import static org.junit.Assert.assertNull;
 import static org.junit.Assert.assertTrue;
-import org.junit.Assert;
+
+import java.util.Calendar;
 
 import org.apache.log4j.Logger;
 import org.joda.time.DateTimeFieldType;
+import org.joda.time.MutableDateTime;
 import org.joda.time.Partial;
+import org.joda.time.ReadableInstant;
 import org.junit.After;
-import org.junit.AfterClass;
+import org.junit.Assert;
 import org.junit.Before;
-import org.junit.BeforeClass;
 import org.junit.Test;
 
+import eu.etaxonomy.cdm.strategy.cache.common.TimePeriodPartialFormatter;
+import eu.etaxonomy.cdm.strategy.parser.TimePeriodParser;
+
 /**
  * @author a.mueller
  *
  */
 public class TimePeriodTest {
+	@SuppressWarnings("unused")
 	private static final Logger logger = Logger.getLogger(TimePeriodTest.class);
 	
 	private TimePeriod onlyStartYear;
 	private TimePeriod onlyEndYear;
 	private TimePeriod startAndEndYear;
 	private TimePeriod noStartAndEndYear;
+	private static final Integer year = 1982;
+	private static final Integer month = 1;
+	private static final Integer day = 5;
 	
-	
-	/**
-	 * @throws java.lang.Exception
-	 */
-	@BeforeClass
-	public static void setUpBeforeClass() throws Exception {
-	}
+		
 
-	/**
-	 * @throws java.lang.Exception
-	 */
-	@AfterClass
-	public static void tearDownAfterClass() throws Exception {
-	}
 
 	/**
 	 * @throws java.lang.Exception
@@ -80,7 +77,9 @@ public class TimePeriodTest {
 	 */
 	@Test
 	public void testNewInstance() {
-		logger.warn("Not yet implemented");
+		TimePeriod tp = TimePeriod.NewInstance();
+		Assert.assertNotNull(tp);
+		Assert.assertTrue("Timeperiod should be empty",tp.isEmpty());
 	}
 
 	/**
@@ -88,7 +87,9 @@ public class TimePeriodTest {
 	 */
 	@Test
 	public void testNewInstancePartial() {
-		logger.warn("Not yet implemented");
+		TimePeriod tp = TimePeriod.NewInstance(new Partial().with(DateTimeFieldType.dayOfWeek(), 5));
+		Assert.assertNotNull(tp);
+		Assert.assertFalse("Timeperiod should not be empty",tp.isEmpty());
 	}
 
 	/**
@@ -96,7 +97,10 @@ public class TimePeriodTest {
 	 */
 	@Test
 	public void testNewInstancePartialPartial() {
-		logger.warn("Not yet implemented");
+		TimePeriod tp = TimePeriod.NewInstance(new Partial().with(DateTimeFieldType.dayOfMonth(),day));
+		Assert.assertNotNull(tp);
+		Assert.assertFalse("Timeperiod should not be empty",tp.isEmpty());
+		Assert.assertEquals("Timeperiod's should not be empty", day, tp.getStartDay());
 	}
 
 	/**
@@ -126,23 +130,50 @@ public class TimePeriodTest {
 	 */
 	@Test
 	public void testNewInstanceCalendar() {
-		logger.warn("Not yet implemented");
+		Calendar cal = Calendar.getInstance();
+		cal.set(1982, 1, day);
+		TimePeriod tp = TimePeriod.NewInstance(cal);
+		Assert.assertNotNull(tp);
+		Assert.assertFalse("Timeperiod should not be empty",tp.isEmpty());
+		Assert.assertEquals("Timeperiod's should not be empty", day, tp.getStartDay());
 	}
 
 	/**
-	 * Test method for {@link eu.etaxonomy.cdm.model.common.TimePeriod#NewInstance(org.joda.time.ReadableInstant)}.
+	 * Test method for {@link eu.etaxonomy.cdm.model.common.TimePeriod#NewInstance(java.util.Calendar, java.util.Calendar)}.
 	 */
 	@Test
-	public void testNewInstanceReadableInstant() {
-		logger.warn("Not yet implemented");
+	public void testNewInstanceCalendarCalendar() {
+		Calendar cal = Calendar.getInstance();
+		cal.set(year, month, day);
+		Calendar cal2 = Calendar.getInstance();
+		Integer day2 = 20;
+		Integer month2 = 7;
+		Integer year2 = 1985;
+		cal2.set(year2, month2, day2);
+		TimePeriod tp = TimePeriod.NewInstance(cal, cal2);
+		Assert.assertNotNull(tp);
+		Assert.assertFalse("Timeperiod should not be empty",tp.isEmpty());
+		Assert.assertEquals("Timeperiod's start should not be equal with cal1", year, tp.getStartYear());
+		//Calendar starts counting months with 0
+		Assert.assertEquals("Timeperiod's start should not be equal with cal1 ", (Integer)(month +1), tp.getStartMonth());
+		Assert.assertEquals("Timeperiod's start should not be equal with cal1", day, tp.getStartDay());
+
+		Assert.assertEquals("Timeperiod's start should not be equal with cal2", year2, tp.getEndYear());
+		//Calendar starts counting months with 0
+		Assert.assertEquals("Timeperiod's start should not be equal with cal2", (Integer)(month2+1), tp.getEndMonth());
+		Assert.assertEquals("Timeperiod's end should not be equal with cal2", day2, tp.getEndDay());
 	}
 
 	/**
-	 * Test method for {@link eu.etaxonomy.cdm.model.common.TimePeriod#NewInstance(java.util.Calendar, java.util.Calendar)}.
+	 * Test method for {@link eu.etaxonomy.cdm.model.common.TimePeriod#NewInstance(org.joda.time.ReadableInstant)}.
 	 */
 	@Test
-	public void testNewInstanceCalendarCalendar() {
-		logger.warn("Not yet implemented");
+	public void testNewInstanceReadableInstant() {
+		ReadableInstant readInst = new MutableDateTime();
+		TimePeriod tp = TimePeriod.NewInstance(readInst);
+		Assert.assertNotNull(tp);
+		Assert.assertFalse("Timeperiod should not be empty",tp.isEmpty());
+		Assert.assertEquals("Timeperiod's should not be empty", (Integer)readInst.get(DateTimeFieldType.dayOfMonth()), (Integer)tp.getStartDay());
 	}
 
 	/**
@@ -150,7 +181,15 @@ public class TimePeriodTest {
 	 */
 	@Test
 	public void testNewInstanceReadableInstantReadableInstant() {
-		logger.warn("Not yet implemented");
+		ReadableInstant readInst = new MutableDateTime();
+		ReadableInstant readInst2 = new MutableDateTime();
+		((MutableDateTime)readInst).addDays(5);
+		TimePeriod tp = TimePeriod.NewInstance(readInst, readInst2);
+		
+		Assert.assertNotNull(tp);
+		Assert.assertFalse("Timeperiod should not be empty",tp.isEmpty());
+		Assert.assertEquals("Timeperiod's day should not be equal to readable instant", (Integer)readInst.get(DateTimeFieldType.dayOfMonth()), tp.getStartDay());
+		Assert.assertEquals("Timeperiod's day should not be equal to readable instant", (Integer)readInst2.get(DateTimeFieldType.dayOfMonth()), tp.getEndDay());
 	}
 
 	/**
@@ -158,7 +197,10 @@ public class TimePeriodTest {
 	 */
 	@Test
 	public void testCalendarToPartial() {
-		logger.warn("Not yet implemented");
+		Calendar cal = Calendar.getInstance();
+		cal.set(year, month, day);
+		Partial part = TimePeriod.calendarToPartial(cal);
+		Assert.assertEquals("Partial's day should not be equal to calednars day", day, (Integer)part.get(DateTimeFieldType.dayOfMonth()));
 	}
 
 	/**
@@ -166,7 +208,10 @@ public class TimePeriodTest {
 	 */
 	@Test
 	public void testReadableInstantToPartial() {
-		logger.warn("Not yet implemented");
+		ReadableInstant readInst = new MutableDateTime();
+		Partial part = TimePeriod.readableInstantToPartial(readInst);
+		part.get(DateTimeFieldType.dayOfMonth());
+		Assert.assertEquals("Partial's day should not be equal to calednars day", (Integer)part.get(DateTimeFieldType.dayOfMonth()), (Integer)part.get(DateTimeFieldType.dayOfMonth()));
 	}
 
 	/**
@@ -196,7 +241,7 @@ public class TimePeriodTest {
 		Assert.assertTrue("Setting the partial should change the string representation of the TimePeriod", !startString.equals(changedString));
 		
 		//
-		tp = TimePeriod.parseString("1752");
+		tp = TimePeriodParser.parseString("1752");
 		assertNull("Freetext should be not set", tp.getFreeText());
 		startString = tp.toString();
 		tp.setStart(newStartDate);
@@ -204,7 +249,7 @@ public class TimePeriodTest {
 		Assert.assertTrue("Setting a partial for a parsed time period should change the string representation of the TimePeriod	", !startString.equals(changedString));
 
 		//
-		tp = TimePeriod.parseString("any strange date");
+		tp = TimePeriodParser.parseString("any strange date");
 		assertNotNull("Freetext should be set", tp.getFreeText());
 		startString = tp.toString();
 		tp.setStart(newStartDate);
@@ -213,7 +258,7 @@ public class TimePeriodTest {
 
 		
 		//
-//		tp = TimePeriod.parseString("15.12.1730"); //TODO currently not parsed
+//		tp = TimePeriodParser.parseString("15.12.1730"); //TODO currently not parsed
 //		
 //		startString = tp.toString();
 //		tp.setStart(newStartDate);
@@ -221,22 +266,6 @@ public class TimePeriodTest {
 //				
 //		Assert.assertTrue("Setting a partial for a parsed time period should change the string representation of the TimePeriod	", !startString.equals(changedString));
 	}
-	
-	/**
-	 * Test method for {@link eu.etaxonomy.cdm.model.common.TimePeriod#TimePeriod(org.joda.time.Partial)}.
-	 */
-	@Test
-	public void testTimePeriodPartial() {
-		logger.warn("Not yet implemented");
-	}
-
-	/**
-	 * Test method for {@link eu.etaxonomy.cdm.model.common.TimePeriod#TimePeriod(org.joda.time.Partial, org.joda.time.Partial)}.
-	 */
-	@Test
-	public void testTimePeriodPartialPartial() {
-		logger.warn("Not yet implemented");
-	}
 
 	/**
 	 * Test method for {@link eu.etaxonomy.cdm.model.common.TimePeriod#isPeriod()}.
@@ -289,127 +318,11 @@ public class TimePeriodTest {
 		tp.setEndYear(2002);
 		Assert.assertEquals("Year should be 1999-2002", "1999-2002", tp.getYear());
 	}
-
-
-	
-	@Test
-	public void testParseSingleDateString() {
-		String strDate = "1756";
-		Partial date = TimePeriod.parseSingleDate(strDate);
-		assertNotNull(date);
-		Assert.assertEquals(Integer.parseInt(strDate), date.get(DateTimeFieldType.year()));
-		try {
-			date.get(DateTimeFieldType.monthOfYear());
-			assertFalse(true); //should not be reached
-		} catch (Exception e) {
-			assertTrue(e instanceof IllegalArgumentException);
-		}
-		try {
-			date.get(DateTimeFieldType.dayOfMonth());
-			assertFalse(true); //should not be reached
-		} catch (Exception e) {
-			assertTrue(e instanceof IllegalArgumentException);
-		}
-		//to be continued
-	}
 	
 	
 	/**
-	 * Test method for {@link eu.etaxonomy.cdm.model.common.TimePeriod#parseString(java.lang.String)}.
+	 * TODO should be partly moved to a test class for {@link TimePeriodPartialFormatter}	
 	 */
-	@Test
-	public void testParseStringString() {
-		String strTimePeriod = "1756";
-		TimePeriod tp1 = TimePeriod.parseString(strTimePeriod);
-		assertNotNull(tp1);
-		Assert.assertEquals(strTimePeriod, tp1.getYear());
-		Assert.assertEquals(strTimePeriod, String.valueOf(tp1.getStartYear()));
-		assertNull(tp1.getEnd());
-		assertNull(tp1.getStartMonth());
-		strTimePeriod = "1756-88";
-		tp1 = TimePeriod.parseString(strTimePeriod);
-		assertNotNull(tp1);
-		Assert.assertEquals("1756-1788", tp1.getYear());
-		Assert.assertEquals("1756", String.valueOf(tp1.getStartYear()));
-		Assert.assertEquals("1788", String.valueOf(tp1.getEndYear()));
-		assertNull(tp1.getEndMonth());
-		assertNull(tp1.getStartMonth());
-		//unparsable
-		String strUnparsablePeriod = "wef 1809-78";
-		TimePeriod tpUnparsable = TimePeriod.parseString(strUnparsablePeriod);
-		assertNotNull(tpUnparsable);
-		Assert.assertEquals(strUnparsablePeriod, tpUnparsable.getFreeText());
-		
-		//"1806"[1807]
-		String strCorrectedPeriod = "\"1806\"[1807]";
-		TimePeriod tpcorrected = TimePeriod.parseString(strCorrectedPeriod);
-		assertNotNull(tpcorrected);
-		Assert.assertEquals(strCorrectedPeriod, tpcorrected.getFreeText());
-		Assert.assertEquals("1807", tpcorrected.getYear());
-		
-		
-		//fl. 1806
-		String strFlPeriod = "fl.  1806?";
-		TimePeriod tpFl = TimePeriod.parseString(strFlPeriod);
-		assertNotNull(tpFl);
-		Assert.assertEquals(strFlPeriod, tpFl.getFreeText());
-		Assert.assertEquals("1806", tpFl.getYear());
-		
-		String strCPeriod = "c.  1806-1810";
-		TimePeriod tpC = TimePeriod.parseString(strCPeriod);
-		assertNotNull(tpC);
-		Assert.assertEquals(strCPeriod, tpC.getFreeText());
-		Assert.assertEquals(Integer.valueOf(1806), tpC.getStartYear());
-		Assert.assertEquals(Integer.valueOf(1810), tpC.getEndYear());
-		Assert.assertEquals("1806-1810", tpC.getYear());
-		
-		//1.1.2011
-		String strDotDate = "1.2.2011";
-		TimePeriod tp = TimePeriod.parseString(strDotDate);
-		assertNotNull(tp);
-		Assert.assertEquals(strDotDate, tp.toString());
-		Assert.assertEquals("2011", tp.getYear());
-		Assert.assertEquals(Integer.valueOf(2), tp.getStartMonth());
-		Assert.assertEquals(Integer.valueOf(1), tp.getStartDay());
-		
-		strDotDate = "31.03.2012";
-		tp = TimePeriod.parseString(strDotDate);
-		assertNotNull(tp);
-		Assert.assertEquals("31.3.2012", tp.toString());
-		Assert.assertEquals("2012", tp.getYear());
-		Assert.assertEquals(Integer.valueOf(3), tp.getStartMonth());
-		Assert.assertEquals(Integer.valueOf(31), tp.getStartDay());
-		
-		strDotDate = "00.04.2013";
-		tp = TimePeriod.parseString(strDotDate);
-		assertNotNull(tp);
-		Assert.assertEquals("4.2013", tp.toString());
-		Assert.assertEquals("2013", tp.getYear());
-		Assert.assertEquals(Integer.valueOf(4), tp.getStartMonth());
-		Assert.assertEquals(null, tp.getStartDay());
-		
-		strDotDate = "13.00.2014";
-		tp = TimePeriod.parseString(strDotDate);
-		assertNotNull(tp);
-		Assert.assertEquals("13.xx.2014", tp.toString());
-		Assert.assertEquals("2014", tp.getYear());
-		Assert.assertEquals(null, tp.getStartMonth());
-		Assert.assertEquals(Integer.valueOf(13), tp.getStartDay());
-		
-		strDotDate = "31.12.2015 - 02.01.2016";
-		tp = TimePeriod.parseString(strDotDate);
-		assertNotNull(tp);
-		Assert.assertEquals("31.12.2015-2.1.2016", tp.toString());
-		Assert.assertEquals("2015-2016", tp.getYear());
-		Assert.assertEquals(Integer.valueOf(2015), tp.getStartYear());
-		Assert.assertEquals(Integer.valueOf(12), tp.getStartMonth());
-		Assert.assertEquals(Integer.valueOf(31), tp.getStartDay());
-		Assert.assertEquals(Integer.valueOf(2016), tp.getEndYear());
-		Assert.assertEquals(Integer.valueOf(1), tp.getEndMonth());
-		Assert.assertEquals(Integer.valueOf(2), tp.getEndDay());
-		
-	}
-	
 	@Test
 	public void testToStringTimePeriod() {
 		TimePeriod tp1 = TimePeriod.NewInstance(1788,1799);
@@ -457,9 +370,7 @@ public class TimePeriodTest {
 	public void testEquals() {
 		Integer startYear = 1788;
 		Integer startMonth = 6;
-		Integer startDay = 25;
 		Integer endDay = 21;
-		Integer endMonth = 12;
 		Integer endYear = 1799;
 		String freeText = "A free period";
 		
diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/description/CategoricalDataTest.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/description/CategoricalDataTest.java
index c3f2e3750b..57cc62d7f4 100644
--- a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/description/CategoricalDataTest.java
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/description/CategoricalDataTest.java
@@ -18,6 +18,8 @@ import org.junit.Assert;
 import org.junit.Before;
 import org.junit.Test;
 
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
+import eu.etaxonomy.cdm.model.common.TermType;
 import eu.etaxonomy.cdm.model.common.TermVocabulary;
 
 /**
@@ -44,17 +46,17 @@ public class CategoricalDataTest {
         TaxonDescription desc = TaxonDescription.NewInstance();
         CategoricalData data = CategoricalData.NewInstance();
         desc.addElement(data);
-        TermVocabulary<State> useCategoryVocabulary = TermVocabulary.NewInstance("Use category vocabulary", "use categories", null, null);
+        TermVocabulary<State> useCategoryVocabulary = TermVocabulary.NewInstance(TermType.Feature, "Use category vocabulary", "use categories", null, null);
         State useCategory1 = State.NewInstance("My first use category", "use category 1", null);
         useCategoryVocabulary.addTerm(useCategory1);
         State useCategory2 = State.NewInstance("My favorite use category", "use category 2", null);
         useCategoryVocabulary.addTerm(useCategory2);
 
         StateData stateData = StateData.NewInstance(useCategory1);
-        data.addState(stateData);
+        data.addStateData(stateData);
         StateData stateData2 = StateData.NewInstance(useCategory2);
-        stateData2.addModifier(Modifier.NewInstance(null, "Any modifer", null));
-        data.addState(stateData2);
+        stateData2.addModifier(DefinedTerm.NewModifierInstance(null, "Any modifer", null));
+        data.addStateData(stateData2);
 
         List<State> states = data.getStatesOnly();
         Assert.assertEquals("There should be 2 states", 2, states.size());
@@ -62,18 +64,18 @@ public class CategoricalDataTest {
     }
 
     /**
-     * Test method for {@link eu.etaxonomy.cdm.model.description.CategoricalData#setStatesOnly(List)}.
+     * Test method for {@link eu.etaxonomy.cdm.model.description.CategoricalData#setStateDataOnly(List)}.
      */
     @Test
     public void testSetStatesOnly() {
         TaxonDescription desc = TaxonDescription.NewInstance();
         CategoricalData data = CategoricalData.NewInstance();
         desc.addElement(data);
-        TermVocabulary<State> useCategoryVocabulary = TermVocabulary.NewInstance("Use category vocabulary", "use categories", null, null);
+        TermVocabulary<State> useCategoryVocabulary = TermVocabulary.NewInstance(TermType.Feature,"Use category vocabulary", "use categories", null, null);
         State useCategory1 = State.NewInstance("My first use category", "use category 1", null);
         useCategoryVocabulary.addTerm(useCategory1);
-        data.addState(useCategory1);
-        Assert.assertEquals("There should be 1 state now", 1, data.getStates().size());
+        data.addStateData(useCategory1);
+        Assert.assertEquals("There should be 1 state now", 1, data.getStateData().size());
 
         State useCategory2 = State.NewInstance("My favorite use category", "use category 2", null);
         useCategoryVocabulary.addTerm(useCategory2);
@@ -83,9 +85,9 @@ public class CategoricalDataTest {
         newStates.addAll(Arrays.asList(useCategory2, useCategory3));
 
         // setting new states and thus removing useCategory1
-        List<StateData> stateDataList = data.setStatesOnly(newStates);
+        List<StateData> stateDataList = data.setStateDataOnly(newStates);
         Assert.assertEquals("There should be 2 StateData objects", 2, stateDataList.size());
-        Assert.assertEquals("There should be 2 StateData objects", 2, data.getStates().size());
+        Assert.assertEquals("There should be 2 StateData objects", 2, data.getStateData().size());
         Assert.assertFalse("Category 1 should not be included anymore", data.getStatesOnly().contains(useCategory1));
         Assert.assertTrue("Category 2 should be included", data.getStatesOnly().contains(useCategory2));
 
diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/description/DescriptionElementTest.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/description/DescriptionElementTest.java
index cef62f0cee..e35c4969fc 100644
--- a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/description/DescriptionElementTest.java
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/description/DescriptionElementTest.java
@@ -16,25 +16,23 @@ import static org.junit.Assert.assertTrue;
 
 import java.util.List;
 
-import org.junit.Assert;
-
-
-
-
 import org.apache.log4j.Logger;
+import org.junit.Assert;
 import org.junit.Before;
 import org.junit.BeforeClass;
 import org.junit.Test;
 
 import eu.etaxonomy.cdm.model.common.DefaultTermInitializer;
-import eu.etaxonomy.cdm.model.common.DescriptionElementSource;
+import eu.etaxonomy.cdm.model.common.DefinedTerm;
 import eu.etaxonomy.cdm.model.common.Language;
 import eu.etaxonomy.cdm.model.common.LanguageString;
+import eu.etaxonomy.cdm.model.common.OriginalSourceType;
+import eu.etaxonomy.cdm.model.common.TermType;
 import eu.etaxonomy.cdm.model.common.TermVocabulary;
 import eu.etaxonomy.cdm.model.media.Media;
 import eu.etaxonomy.cdm.model.name.BotanicalName;
 import eu.etaxonomy.cdm.model.name.Rank;
-import eu.etaxonomy.cdm.model.occurrence.Specimen;
+import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
 import eu.etaxonomy.cdm.model.reference.Reference;
 import eu.etaxonomy.cdm.model.reference.ReferenceFactory;
 import eu.etaxonomy.cdm.model.taxon.Taxon;
@@ -71,17 +69,17 @@ private static Logger logger = Logger.getLogger(DescriptionElementTest.class);
 		Media media = Media.NewInstance(null, 1000, "jpeg", null);
 		categorialData.addMedia(media);
 		
-		DescriptionElementSource source = DescriptionElementSource.NewInstance();
+		DescriptionElementSource source = DescriptionElementSource.NewInstance(OriginalSourceType.Unknown);
 		Reference<?> citation = ReferenceFactory.newArticle();
 		citation.setTitle("Test");
 		source.setCitation(citation);
 		categorialData.addSource(source );
 		StateData state = StateData.NewInstance();
-		categorialData.addState(state);
+		categorialData.addStateData(state);
 		
 		indAssociation = IndividualsAssociation.NewInstance();
 		
-		Specimen associatedSpecimen = Specimen.NewInstance();
+		DerivedUnit associatedSpecimen = DerivedUnit.NewPreservedSpecimenInstance();
 		associatedSpecimen.setIndividualCount(2);
 		
 		indAssociation.setAssociatedSpecimenOrObservation(associatedSpecimen);
@@ -111,8 +109,8 @@ private static Logger logger = Logger.getLogger(DescriptionElementTest.class);
 	@Test
 	public void testCloneCategorialData(){
 		CategoricalData clone = (CategoricalData)categorialData.clone();
-		assertEquals(clone.getStates().size(),categorialData.getStates().size() );
-		assertSame(clone.getStates().get(0), categorialData.getStates().get(0));
+		assertEquals(clone.getStateData().size(),categorialData.getStateData().size() );
+		assertSame(clone.getStateData().get(0), categorialData.getStateData().get(0));
 		assertNotSame(clone, categorialData);
 			
 	}
@@ -146,25 +144,26 @@ private static Logger logger = Logger.getLogger(DescriptionElementTest.class);
 		CategoricalData data = CategoricalData.NewInstance();
 		desc.addElement(data);
 		StateData stateData = StateData.NewInstance();
-		data.addState(stateData);
+		data.addStateData(stateData);
 		
-		TermVocabulary<Modifier> plantPartVoc = TermVocabulary.NewInstance("plant parts", "plant parts", "parts", null);
-		Modifier leaf = Modifier.NewInstance("leaf", "leaf", null);
+		TermType modifierType = TermType.Modifier;
+		TermVocabulary<DefinedTerm> plantPartVoc = TermVocabulary.NewInstance(modifierType,"plant parts", "plant parts", "parts", null);
+		DefinedTerm leaf = DefinedTerm.NewModifierInstance("leaf", "leaf", null);
 		plantPartVoc.addTerm(leaf);
 		data.addModifier(leaf);
-		Modifier peduncle = Modifier.NewInstance("peduncle", "peduncle", null);
+		DefinedTerm peduncle = DefinedTerm.NewModifierInstance("peduncle", "peduncle", null);
 		plantPartVoc.addTerm(peduncle);
 		data.addModifier(peduncle);
-		Modifier notExistingPart = Modifier.NewInstance("not existing part", "not existing part", null);
+		DefinedTerm notExistingPart = DefinedTerm.NewModifierInstance("not existing part", "not existing part", null);
 		plantPartVoc.addTerm(notExistingPart);
 
-		TermVocabulary<Modifier> ethnicGroupVoc = TermVocabulary.NewInstance("An ethnic group", "ethnic group", null, null);
-		Modifier scots = Modifier.NewInstance("Scots ", "Scots", null);
+		TermVocabulary<DefinedTerm> ethnicGroupVoc = TermVocabulary.NewInstance(TermType.Modifier,"An ethnic group", "ethnic group", null, null);
+		DefinedTerm scots = DefinedTerm.NewModifierInstance("Scots ", "Scots", null);
 		ethnicGroupVoc.addTerm(scots);
 		data.addModifier(scots);
 
 		
-		List<Modifier> modifiers = data.getModifiers(plantPartVoc);
+		List<DefinedTerm> modifiers = data.getModifiers(plantPartVoc);
 		Assert.assertEquals("There should be 2 modifiers of type 'plant part'", 2, modifiers.size());
 		Assert.assertEquals("There should be 3 terms in the 'plant part' vocabulary", 3, plantPartVoc.size());
 		Assert.assertEquals("There should be 1 modifiers of type 'ethnic group'", 1, data.getModifiers(ethnicGroupVoc).size());
@@ -172,10 +171,6 @@ private static Logger logger = Logger.getLogger(DescriptionElementTest.class);
 		
 	}
 	
-	
-	
-	
-
 }
 
 
diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/description/FeatureTreeTest.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/description/FeatureTreeTest.java
index df3bfdc949..a0fa1211e2 100644
--- a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/description/FeatureTreeTest.java
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/description/FeatureTreeTest.java
@@ -66,8 +66,8 @@ public class FeatureTreeTest {
 		node21.setFeature(Feature.ANATOMY());
 		node1.addChild(node21, 1);
 		
-		assertEquals(node1.getChildren().size(), 2);
-		assertEquals(node1.getChildren().get(1), node21);
+		assertEquals(node1.getChildNodes().size(), 2);
+		assertEquals(node1.getChildNodes().get(1), node21);
 		
 		
 		assertEquals(node21.getParent(), node1);
diff --git a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/location/NamedAreaTest.java b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/location/NamedAreaTest.java
index e7657476a8..eacc52284a 100644
--- a/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/location/NamedAreaTest.java
+++ b/cdmlib-model/src/test/java/eu/etaxonomy/cdm/model/location/NamedAreaTest.java
@@ -67,8 +67,8 @@ public class NamedAreaTest {
 	@Test
 	public void labelWithLevelTest(){
 		Assert.assertEquals("Named Area 1 - Level 1", NamedArea.labelWithLevel(namedArea1, Language.DEFAULT()));
-		Assert.assertEquals("Germany - WaterbodyOrCountry", NamedArea.labelWithLevel(WaterbodyOrCountry.GERMANY(), Language.DEFAULT()));
-		Assert.assertEquals("Germany - TDWG Level 3", NamedArea.labelWithLevel(TdwgArea.getAreaByTdwgAbbreviation("GER"), Language.DEFAULT()));
+		Assert.assertEquals("Germany - Country", NamedArea.labelWithLevel(Country.GERMANY(), Language.DEFAULT()));
+		Assert.assertEquals("Germany - TDWG Level 3", NamedArea.labelWithLevel(getAreaByTdwgAbbreviation("GER"), Language.DEFAULT()));
 		NamedArea namedArea2 = NamedArea.NewInstance("Description for Named Area 2", "", "NA2");
 		Assert.assertEquals("NA2 - NamedArea", NamedArea.labelWithLevel(namedArea2, Language.DEFAULT()));
 		NamedArea namedArea3 = NamedArea.NewInstance("Description for Named Area 3", null, " ");
@@ -81,18 +81,18 @@ public class NamedAreaTest {
 	public void getHiearchieListTest(){
 		//Create example data
 		List<NamedArea> list = new ArrayList<NamedArea>(); 
-		NamedArea germanyL4 = TdwgArea.getAreaByTdwgAbbreviation("GER-OO");
+		NamedArea germanyL4 = getAreaByTdwgAbbreviation("GER-OO");
 		Assert.assertNotNull("Prerequisite: Germany should not be null", germanyL4);
 		list.add(germanyL4);
-		NamedArea franceL3 = TdwgArea.getAreaByTdwgAbbreviation("FRA");
+		NamedArea franceL3 = getAreaByTdwgAbbreviation("FRA");
 		Assert.assertNotNull("Prerequisite: France should not be null", germanyL4);
 		list.add(franceL3);
-		NamedArea europe = TdwgArea.getAreaByTdwgAbbreviation("1");
-		NamedArea middleEurope = TdwgArea.getAreaByTdwgAbbreviation("11");
+		NamedArea europe = getAreaByTdwgAbbreviation("1");
+		NamedArea middleEurope = getAreaByTdwgAbbreviation("11");
 //		System.out.println(middleEurope.getLabel());
-		NamedArea southWestEurope = TdwgArea.getAreaByTdwgAbbreviation("12");
+		NamedArea southWestEurope = getAreaByTdwgAbbreviation("12");
 //		System.out.println(southWestEurope.getLabel());
-		NamedArea germanyL3 = TdwgArea.getAreaByTdwgAbbreviation("GER");
+		NamedArea germanyL3 = getAreaByTdwgAbbreviation("GER");
 		
 		NamedArea newArea1 = NamedArea.NewInstance("New Area1 Description", "New Area1", "NA1");
 		list.add(newArea1);
@@ -170,10 +170,11 @@ public class NamedAreaTest {
 				
 			
 		
-		System.out.println(root.toString(true, 0));
-		
-		
+		System.out.println(root.toString(true, 0));	
 	}
 	
+	private NamedArea getAreaByTdwgAbbreviation(String tdwgAbbrev){
+		return NamedArea.getAreaByTdwgAbbreviation(tdwgAbbrev);
+	}
 
 }
